# - Find DUMB
# Find the native DUMB includes and libraries
#
#  DUMB_INCLUDE_DIR - where to find DUMB headers.
#  DUMB_LIBRARIES   - List of libraries when using libDUMB.
#  DUMB_FOUND       - True if libDUMB found.

if(DUMB_INCLUDE_DIR)
    # Already in cache, be silent
    set(DUMB_FIND_QUIETLY TRUE)
    set(DUMB_LIBRARIES dumb m)
    set(DUMB_FOUND TRUE)
endif(DUMB_INCLUDE_DIR)

find_path(DUMB_INCLUDE_DIR dumb.h)

find_library(DUMB_LIBRARY NAMES dumb libdumb)
find_library(MATH_LIBRARY NAMES m libm)


set(DUMB_LIBRARIES ${DUMB_LIBRARY} ${MATH_LIBRARY})
set(DUMB_FOUND TRUE)

mark_as_advanced(DUMB_INCLUDE_DIR DUMB_LIBRARY)
